25'ten fazla konu seçemezsiniz Konular bir harf veya rakamla başlamalı, kısa çizgiler ('-') içerebilir ve en fazla 35 karakter uzunluğunda olabilir.

73 satır
1.2 KiB

6 yıl önce
#!/usr/bin/env bash
6 yıl önce
declare -r esc=$'\033'
declare -r c_reset="${esc}[0m"
declare -r c_red="${esc}[31m"
6 yıl önce
declare -r fifo='/tmp/sshget.fifo'
declare -A domains=()
declare -A paths=()
declare -a files=()
err() {
printf "${c_red}%s${c_reset}\n" "$*" >&2
}
die() {
exit 1
}
6 yıl önce
usage() {
LESS=-FEXR less <<'HELP'
sshget <user@host1:/path/to/search ...>
HELP
}
has() {
6 yıl önce
local verbose=0
if [[ $1 = '-v' ]]; then
6 yıl önce
verbose=1
shift
fi
6 yıl önce
for c; do c="${c%% *}"
if ! command -v "$c" &> /dev/null; then
6 yıl önce
(( verbose > 0 )) && err "$c not found"
return 1
fi
done
}
has -v fzf rsync || die
6 yıl önce
cleanup() {
[[ -e "$fifo" ]] && rm "$fifo"
}
trap cleanup SIGHUP SIGINT SIGTERM
mkfifo "$fifo"
6 yıl önce
if (( $# < 1 )); then
usage
die
fi
6 yıl önce
for a; do
6 yıl önce
host="${a%:*}"
6 yıl önce
path="${a##*:}"
domains+=( ["$a"]="$host" )
paths+=( ["$a"]="$path" )
shift
done
for s in "${!domains[@]}"; do
6 yıl önce
ssh "${domains[$s]}" "find ${paths[$s]}" | sed -r "s|^|${domains[$s]}:|" >> "$fifo" &
6 yıl önce
done
4 yıl önce
mapfile -t files < <(fzf -e --inline-info +s --multi --cycle --bind='Ctrl-A:toggle-all,`:jump' < "$fifo")
6 yıl önce
if (( ${#files[@]} )); then
rsync --protect-args -auvzP -e ssh "${files[@]}" .
6 yıl önce
fi
cleanup